namespace Brizco.Repository.Handlers.Shift;

public class DeletePositionCommandHandler : IRequestHandler<DeleteShiftCommand, bool>
{
    private readonly IRepositoryWrapper _repositoryWrapper;

    public DeletePositionCommandHandler(IRepositoryWrapper repositoryWrapper)
    {
        _repositoryWrapper = repositoryWrapper;
    }
    public async Task<bool> Handle(DeleteShiftCommand request, CancellationToken cancellationToken)
    {
        var shift = await _repositoryWrapper.SetRepository<Domain.Entities.Shift.Shift>()
            .TableNoTracking
            .FirstOrDefaultAsync(s => s.Id == request.Id, cancellationToken);
        if (shift == null)
            throw new AppException("Routine not found", ApiResultStatusCode.NotFound);
        _repositoryWrapper.SetRepository<Domain.Entities.Shift.Shift>()
            .Delete(shift);

        await _repositoryWrapper.SaveChangesAsync(cancellationToken);
        return true;
    }
}